clear all; clc

load connectivityAAL.mat
connectivity = connectivity_rest_AAL;

load Efficiency.mat

load CognPerformance.mat
load ClinicalData.mat
load Sociodemographics.mat

IC(1:46)=1;
IC(22) = 0; %scrubbing

%IC(37) = 0; %ProcessingSpeed

%IC(8) = 0; %PsychomotorSpeed & ReactionTime

Performance = CognFlex;

Subject = 1:sum(IC);

    n = 90;  
    n2 = 45;       
    intramodule = false(n);
    intramoduleleft = false(n2);     
    intramoduleright = false(n2);     

for subj = 1:size(connectivity,3)
    for cost = 1:9,
    Wfc = connectivity(1:n,1:n,subj);
      
    Wfc(Wfc < 0) = 0; 
    WleftROI = Wfc([1:2:89],[1:2:89]);            
    WrightROI = Wfc([2:2:90],[2:2:90]); 
    
    threshold = 0.10+(cost-1)*.05;
    Wfc= threshold_proportional(Wfc,threshold);
    WleftROI= threshold_proportional(WleftROI,threshold);
    WrightROI= threshold_proportional(WrightROI,threshold);

    [M(subj,cost,:),Q(subj,cost)]=modularity_und(Wfc,1); 
       
    [Mleft(subj,cost,:),Qleft(subj,cost)]=modularity_und(WleftROI,1);
    
    [Mright(subj,cost,:),Qright(subj,cost)]=modularity_und(WrightROI,1);

    acw(subj,cost)= mean(nonzeros(Wfc));   %average connection weight
    acwleft(subj,cost)= mean(nonzeros(WleftROI)); 
    acwright(subj,cost)= mean(nonzeros(WrightROI)); 
    
    %assortativity 
    R(subj,cost) = assortativity_wei(Wfc,0);                
    Rleft(subj,cost) = assortativity_wei(WleftROI,0);
    Rright(subj,cost) = assortativity_wei(WrightROI,0);
    
    for i = 1:n; for j = 1:n
        intramodule(i,j,subj) = M(subj,cost,i)==M(subj,cost,j);      
    end;end;

    for i = 1:n2; for j = 1:n2
        intramoduleleft(i,j,subj) = Mleft(subj,cost,i)==Mleft(subj,cost,j);
        intramoduleright(i,j,subj) = Mright(subj,cost,i)==Mright(subj,cost,j);
    end;end;
    
intermodule = ~intramodule;
IntraM(subj,cost) = mean(nonzeros(Wfc(intramodule(:,:,subj))));
InterM(subj,cost) = mean(nonzeros(Wfc(intermodule(:,:,subj))));

intermoduleleft = ~intramoduleleft;
IntraMleft(subj,cost) = mean(nonzeros(WleftROI(intramoduleleft(:,:,subj))));
InterMleft(subj,cost) = mean(nonzeros(WleftROI(intermoduleleft(:,:,subj))));

intermoduleright = ~intramoduleright;
IntraMright(subj,cost) = mean(nonzeros(WrightROI(intramoduleright(:,:,subj))));
InterMright(subj,cost) = mean(nonzeros(WrightROI(intermoduleright(:,:,subj))));

    %strength
    S(subj,cost)=mean(sum(Wfc,2));    %Strength: mean across all nodes, sum of connection weights
    Sleft(subj,cost)=mean(sum(WleftROI));   %left ROIs
    Sright(subj,cost)=mean(sum(WrightROI));   %right ROIs

    end;
end;

%Left = laesie; right = healthy
%%%-----------------------------------------------------------------------------
tbl1 = table(mean(Sright(find(IC==1),:),2),mean(Rright(find(IC==1),:),2),mean(Qright(find(IC==1),:),2),mean(Global_effright(find(IC==1),:),2),mean(Local_effright(find(IC==1),:),2),age(find(IC==1),:),TumorType(find(IC==1),:),TumorVolume(find(IC==1),:),Gender(find(IC==1),:),Handedness(find(IC==1),:),EPIPresto(find(IC==1))',Epilepsy(find(IC==1),:),AED(find(IC==1),:),Performance(find(IC==1),:),Subject','VariableNames',{'Strength_right','Assortativity_right','ModularityQ_right','Globaleff_right','Localeff_right','age','TumorType','TumorVolume','Gender','Handedness','EPIPresto','Epilepsy','AED','Performance','Subject'});
tbl1.education = nominal(education(find(IC==1),:));

%Execute separately per graph metric
lm1=fitlm(tbl1,'Performance~age+TumorType+Assortativity_right');

